Package: faviconPlease
Title: Find the URL to the 'Favicon' for a Website
Version: 0.2.0
Authors@R: 
    person(given = "John",
           family = "Blischak",
           role = c("aut", "cre"),
           email = "jdblischak@gmail.com")
Description: Finds the URL to the 'favicon' for a website. This is useful if you
  want to display the 'favicon' in an HTML document or web application,
  especially if the website is behind a firewall.
URL: https://github.com/jdblischak/faviconPlease
BugReports: https://github.com/jdblischak/faviconPlease/issues
Imports: utils, xml2
Suggests: httr, tinytest (>= 1.0.0), ttdo
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.3.3
NeedsCompilation: no
Packaged: 2026-01-14 14:19:33 UTC; john
Author: John Blischak [aut, cre]
Maintainer: John Blischak <jdblischak@gmail.com>
Repository: CRAN
Date/Publication: 2026-01-14 14:50:02 UTC
Built: R 4.6.0; ; 2026-04-25 18:50:48 UTC; unix

<!-- README.md is generated from README.Rmd. Please edit that file -->

# faviconPlease

[![CRAN
status](https://www.r-pkg.org/badges/version/faviconPlease)](https://cran.r-project.org/package=faviconPlease)
[![R-CMD-check](https://github.com/jdblischak/faviconPlease/workflows/R-CMD-check/badge.svg)](https://github.com/jdblischak/faviconPlease/actions)

Finds the URL to the ‘favicon’ for a website. This is useful if you want
to display the ‘favicon’ in an HTML document or web application,
especially if the website is behind a firewall.

``` r
library(faviconPlease)
faviconPlease("https://github.com/")
```

    ## [1] "https://github.githubassets.com/favicons/favicon.svg"

Also check out my [blog post on
faviconPlease](https://blog.jdblischak.com/posts/faviconplease/) for
more background and examples.

## Installation

Install latest release from CRAN:

``` r
install.packages("faviconPlease")
```

Install development version from GitHub:

``` r
install.packages("remotes")
remotes::install_github("jdblischak/faviconPlease")
```

## Code of Conduct

Please note that the faviconPlease project is released with a
[Contributor Code of
Conduct](https://contributor-covenant.org/version/2/0/CODE_OF_CONDUCT.html).
By contributing to this project, you agree to abide by its terms.

## Default strategy

By default, `faviconPlease()` uses the following strategy to find the
URL to the favicon for a given website. It stops once it finds a URL and
returns it.

1.  Download the HTML file and search its `<head>` for any `<link>`
    elements with `rel="icon"` or `rel="shortcut icon"`.

2.  Download the HTML file at the root of the server (i.e. discard the
    path) and search its `<head>` for any `<link>` elements with
    `rel="icon"` or `rel="shortcut icon"`.

3.  Attempt to download a file called `favicon.ico` at the root of the
    server. This is the default location that a browser looks if the
    HTML file does not specify an alternative location in a `<link>`
    element. If the file `favicon.ico` is successfully downloaded, then
    this URL is returned.

4.  If the above steps fail, as a fallback, use the [favicon
    service](https://duckduckgo.com/duckduckgo-help-pages/privacy/favicons/)
    provided by the search engine [DuckDuckGo](https://duckduckgo.com/).
    This provides a nice default for websites that don’t have a favicon
    (or can’t be easily found).

## Extending faviconPlease

The default strategy above is designed to reliably get you a favicon URL
for most websites. However, you can customize it as needed.

### Change the fallback to use Google’s favicon service

The default fallback function is `faviconDuckDuckGo()`. To instead use
Google’s favicon service, you can set the argument
`fallback = faviconGoogle`.

Note that neither DuckDuckGo nor Google have every favicon you might
expect. And the availability can change over time. You can see some
examples in my [blog
post](https://blog.jdblischak.com/posts/faviconplease/). Fortunately
they both provide a generic favicon to insert when they don’t have the
favicon.

### Use a custom fallback function

You can use your own custom fallback function instead. It must accept
one argument, which is the server, e.g. `"github.com"`. The easiest
approach would be to copy-paste one of the existing fallback functions
and modify it to use your alternative favicon service.

``` r
args(faviconDuckDuckGo)
```

    ## function (server) 
    ## NULL

``` r
body(faviconDuckDuckGo)
```

    ## {
    ##     iconService <- "https://icons.duckduckgo.com/ip3/%s.ico"
    ##     favicon <- sprintf(iconService, server)
    ##     return(favicon)
    ## }

### Use a custom fallback favicon

If you have a URL to a generic favicon file that you would like to use
as a fallback, you can directly pass this as a character vector. It
could also be a path to an image file on the server where your app is
running.

### Change the order of the favicon functions

The default strategy first checks the `<head>` for a link to the favicon
file and then checks for the availability of the file `favicon.ico`. You
can change this order, or only perform one of them, by changing the
argument `functions` passed to `faviconPlease()`. It should be a list of
functions.

``` r
# default
functions = list(faviconLink, faviconIco)
# Switch the order
functions = list(faviconIco, faviconLink)
# Only search <head>
functions = list(faviconLink)
# Only check for favicon.ico
functions = list(faviconIco)
# Skip the favicon functions entirely and just use the fallback
functions = NULL
```

### Use a custom favicon function

You can also create your own custom favicon function to pass to
`faviconPlease()`. By default it must accept 3 arguments. It will be
passed the URL’s scheme (e.g. `"https"`), server (e.g. `"github.com"`),
and path (e.g. `"/jdblischak/faviconPlease"`). Your function should
return the URL to a favicon or an empty string, `""`, if it can’t find
one.

``` r
# Favicon functions must accept at least 3 positional arguments
args(faviconLink)
```

    ## function (scheme, server, path) 
    ## NULL

As a concrete example, here is a custom function for searching for
`favicon.ico` on Ubuntu 20.04, which has increased security settings
(see troubleshooting section below).

``` r
faviconIcoUbuntu20 <- function(scheme, server, path) {
  faviconIco(scheme, server, path, method = "wget",
             extra = c("--no-check-certificate",
                       "--ciphers=DEFAULT:@SECLEVEL=1"))
}
```

It calls `faviconIco()` with the specific settings needed by
`download.file()` to work on Ubuntu 20.04. You could then use your
custom function instead of the default `faviconIco()` by calling
`faviconPlease()` with
`functions = list(faviconLink, faviconIcoUbuntu20)`.

Note that the example function `faviconIcoUbuntu20()` will likely fail
on Windows, macOS, and Ubuntu versions prior to 20.04.

## Troubleshooting

Unfortunately it’s not easy to make this fool proof for all operating
systems and all websites. Here are some known issues:

1.  `download.file()`, used by `faviconIco()`, is known to have
    cross-platform issues. Thus the official documentation in
    `?download.file` recommends:

    > Setting the `method` should be left to the end user.

    Accordingly, `faviconIco()` exposes the arguments `method`, `extra`,
    and `headers`, which are passed directly to `download.file()`.
    Alternatively you can set the global options
    `"download.file.method"` or `"download.file.extra"`.

2.  Ubuntu 20.04 increased its default security settings for downloading
    files from the internet
    ([details](https://bugs.launchpad.net/ubuntu/+source/openssl/+bug/1864689)).
    Unfortunately many websites have not updated their SSL certificates
    to comply with the increased security restrictions. `faviconLink()`
    has a workaround for this situation, but not `faviconIco()`. As an
    example, here’s how you could detect the availability of favicon.ico
    for the Ensembl website on Ubuntu 20.

    ``` r
    faviconIco("https", "www.ensembl.org", "",
               method = "wget", extra = c("--no-check-certificate",
                                              "--ciphers=DEFAULT:@SECLEVEL=1"))
    ```

    Alternatively, if it’s an option for you, you could avoid this
    workaround by using the previous Ubuntu LTS release 18.04. Also note
    that the above command will fail on Ubuntu 18.04 because the default
    `wget` installed doesn’t have the argument `--ciphers`.

source("tinytest-settings.R")
using("ttdo")

if (at_home()) {
  expect_identical_xl(
    faviconIco("https", "www.genome.jp", "/kegg-bin/show_pathway"),
    "https://www.genome.jp/favicon.ico"
  )

  expect_identical_xl(
    faviconPlease("https://www.genome.jp/kegg-bin/show_pathway?map00410"),
    "https://www.genome.jp/favicon.ico"
  )

  expect_identical_xl(
    faviconIco("https", "www.phosphosite.org", ""),
    "https://www.phosphosite.org/favicon.ico"
  )

  expect_identical_xl(
    faviconPlease("https://www.phosphosite.org/"),
    "https://www.phosphosite.org/favicon.ico"
  )

  expect_identical_xl(
    faviconIco("http", "www.informatics.jax.org", "/searchtool/Search.do?query="),
    "http://www.informatics.jax.org/favicon.ico"
  )

  expect_identical_xl(
    faviconIco("https", "www.ncbi.nlm.nih.gov",
               "/CCDS/CcdsBrowse.cgi?REQUEST=CCDS&ORGANISM=9606&BUILDS=CURRENTBUILDS&DATA="),
    "https://www.ncbi.nlm.nih.gov/favicon.ico"
  )
}

source("tinytest-settings.R")
using("ttdo")

expect_identical_xl(
  faviconDuckDuckGo("address.domain"),
  "https://icons.duckduckgo.com/ip3/address.domain.ico"
)

expect_identical_xl(
  faviconPlease("https://address.domain/path", functions = NULL),
  "https://icons.duckduckgo.com/ip3/address.domain.ico"
)

source("tinytest-settings.R")
using("ttdo")

# Invalid links
expect_error_xl(
  faviconPlease(1),
  "The argument `links` must be a character vector of URLs"
)

# Invalid functions
expect_error_xl(
  faviconPlease("https://www.r-project.org", functions = 1),
  "The argument `functions` must be a list of functions or NULL"
)

# Invalid fallback
expect_error_xl(
  faviconPlease("https://www.r-project.org/", fallback = 1),
  "The argument `fallback` must be a function with one argument or a single character string"
)

expect_error_xl(
  faviconPlease("https://www.r-project.org/", fallback = c("a", "b")),
  "The argument `fallback` must be a function with one argument or a single character string"
)

expect_error_xl(
  faviconPlease("https://www.r-project.org/", fallback = function(x, y) 1),
  "The argument `fallback` must be a function with one argument or a single character string"
)

source("tinytest-settings.R")
using("ttdo")

if (!at_home()) exit_file("Only test ensembl \"at_home\"")

# EBI sites like Ensembl and UniProt are critical for OmicNavigator, but can be
# extremely flaky due to SSL certificate issues, redirecting to mirrors, and
# differences in the HTML <head> between the mirrors

# useast.ensembl.org -----------------------------------------------------------

# https://useast.ensembl.org/
#
# <link type="image/png" href="/i/ensembl-favicon.png" rel="icon" />

expect_identical_xl(
  basename(
    faviconLink("https", "useast.ensembl.org", "/Homo_sapiens/Gene/Summary")
  ),
  "ensembl-favicon.png"
)

expect_identical_xl(
  basename(
    faviconPlease("https://useast.ensembl.org/Homo_sapiens/Gene/Summary?g=")
  ),
  "ensembl-favicon.png"
)

# www.ensembl.org --------------------------------------------------------------

# https://www.ensembl.org/?redirect=no
#
# <link type="image/png" rel="icon" href="//static.ensembl.org/i/ensembl-favicon.png" />

# The browser clearly shows the URL "//static.ensembl.org/i/ensembl-favicon.png".
# And this works on my personal laptop. But on GitHub Actions and my work
# laptop, it somehow returns "/i/ensembl-favicon.png". I haven't been able to
# figure out the source of the discrepancy, and at the end of the day, it
# doesn't matter as long as it returns a valid favicon path

expect_identical_xl(
  basename(
    faviconLink("https", "ensembl.org", "/Homo_sapiens/Gene/Summary")
  ),
  "ensembl-favicon.png"
)

expect_identical_xl(
  basename(
    faviconPlease("https://ensembl.org/Homo_sapiens/Gene/Summary?g=")
  ),
  "ensembl-favicon.png"
)

# So far I could only get the favicon.ico with utils::download.file() with
# `wget --no-check-certificate`
if (Sys.which("wget") != "") {
  os <- utils::osVersion
  # Ubuntu 20.04 (focal) requires extra security settings, but the argument
  # --ciphers isn't available for the version of wget on Ubuntu 18.04
  # (bionic).
  # https://stackoverflow.com/a/62359497
  if (isTRUE(startsWith(os, "Ubuntu 20"))) {
    # apex domain
    expect_identical_xl(
      faviconIco("https", "ensembl.org", "/Homo_sapiens/Gene/Summary",
                 method = "wget", extra = c("--no-check-certificate",
                                            "--ciphers=DEFAULT:@SECLEVEL=1")),
      "https://ensembl.org/favicon.ico"
    )
    # www subdomain
    expect_identical_xl(
      faviconIco("https", "www.ensembl.org", "/Homo_sapiens/Gene/Summary",
                 method = "wget", extra = c("--no-check-certificate",
                                            "--ciphers=DEFAULT:@SECLEVEL=1")),
      "https://www.ensembl.org/favicon.ico"
    )
  } else {
    # apex domain
    expect_identical_xl(
      faviconIco("https", "ensembl.org", "/Homo_sapiens/Gene/Summary",
                 method = "wget", extra = "--no-check-certificate"),
      "https://ensembl.org/favicon.ico"
    )
    # www subdomain
    expect_identical_xl(
      faviconIco("https", "www.ensembl.org", "/Homo_sapiens/Gene/Summary",
                 method = "wget", extra = "--no-check-certificate"),
      "https://www.ensembl.org/favicon.ico"
    )
  }
} else {
  message("wget is not available")
}

# uniprot.org ------------------------------------------------------------------

# uniprot.org is also owned by EBI, so it suffers from the same complications
# caused by Ubuntu 20's increased security settings.
# https://github.com/Ensembl/ensembl-rest/issues/427#issuecomment-629268281


# <link type="image/vnd.microsoft.icon" href="/favicon.ico" rel="shortcut icon"/>
expect_identical_xl(
  faviconLink("https", "www.uniprot.org", "/uniprot/"),
  "https://www.uniprot.org/mstile-144x144.png"
)

# So far I could only get the favicon.ico with utils::download.file() with
# `wget --no-check-certificate`
if (Sys.which("wget") != "") {
  os <- utils::osVersion
  # Ubuntu 20.04 (focal) requires extra security settings, but the argument
  # --ciphers isn't available for the version of wget on Ubuntu 18.04
  # (bionic).
  # https://stackoverflow.com/a/62359497
  if (isTRUE(startsWith(os, "Ubuntu 20"))) {
    expect_identical_xl(
      faviconIco("https", "www.uniprot.org", "/uniprot/",
                 method = "wget", extra = c("--no-check-certificate",
                                            "--ciphers=DEFAULT:@SECLEVEL=1")),
      "https://www.uniprot.org/favicon.ico"
    )
  } else {
    expect_identical_xl(
      faviconIco("https", "www.uniprot.org", "/uniprot/",
                 method = "wget", extra = "--no-check-certificate"),
      "https://www.uniprot.org/favicon.ico"
    )
  }
} else {
  message("wget is not available")
}

expect_identical_xl(
  faviconPlease("https://www.uniprot.org/uniprot/"),
  "https://www.uniprot.org/mstile-144x144.png"
)

source("tinytest-settings.R")
using("ttdo")

expect_identical_xl(
  faviconGoogle("address.domain"),
  "https://www.google.com/s2/favicons?domain_url=address.domain"
)

expect_identical_xl(
  faviconPlease("https://address.domain/path", functions = NULL, fallback = faviconGoogle),
  "https://www.google.com/s2/favicons?domain_url=address.domain"
)

source("tinytest-settings.R")
using("ttdo")

useFileProtocol <- function(filepath) {
  if (.Platform$OS.type == "windows") {
    prefix <- "file:///"
  } else {
    prefix <- "file://"
  }
  paste0(prefix, normalizePath(filepath, winslash = "/"))
}

fileNoLink <- useFileProtocol("testFiles/no-link.html")

expect_identical_xl(
  faviconPlease(fileNoLink, functions = list(faviconLink), fallback = ""),
  "",
  info = "No link"
)

fileAbsolute <- useFileProtocol("testFiles/absolute.html")

expect_identical_xl(
  faviconPlease(fileAbsolute, functions = list(faviconLink), fallback = ""),
  "https://absolute.com/custom.png",
  info = "Absolute link"
)

fileProtocolRelative <- useFileProtocol("testFiles/protocol-relative.html")

expect_identical_xl(
  faviconPlease(fileProtocolRelative, functions = list(faviconLink), fallback = ""),
  "file://protocol-relative.com/custom.png",
  info = "Protocol-relative link"
)

fileRootRelative <- useFileProtocol("testFiles/root-relative.html")

expect_identical_xl(
  faviconPlease(fileRootRelative, functions = list(faviconLink), fallback = ""),
  "file:///root-relative/custom.png",
  info = "Root-relative link"
)

fileRootRelativeWithBase <- useFileProtocol("testFiles/root-relative-with-base.html")

expect_identical_xl(
  faviconPlease(fileRootRelativeWithBase, functions = list(faviconLink), fallback = ""),
  "file:///root-relative/custom.png",
  info = "Root-relative link with base"
)

fileRelative <- useFileProtocol("testFiles/relative.html")
iconRelativeExpected <- file.path(dirname(fileRelative), "custom.png")

expect_identical_xl(
  suppressWarnings(
    faviconPlease(fileRelative, functions = list(faviconLink), fallback = "")
  ),
  iconRelativeExpected,
  info = "Relative link"
)

# Examples ---------------------------------------------------------------------

if (at_home()) {
  # Example of absolute link with rel="icon"
  expect_identical_xl(
    faviconLink("https", "stephenslab.github.io", "/wflow-divvy/"),
    "https://github.com/workflowr/workflowr-assets/raw/master/img/reproducible.png"
  )

  expect_identical_xl(
    faviconPlease("https://stephenslab.github.io/wflow-divvy/"),
    "https://github.com/workflowr/workflowr-assets/raw/master/img/reproducible.png"
  )

  # Example of root-relative link with rel="shortcut icon"
  expect_identical_xl(
    faviconLink("https", "reactome.org", "/content/detail/R-HSA-983712"),
    "https://reactome.org/templates/favourite/favicon.ico"
  )

  expect_identical_xl(
    faviconPlease("https://reactome.org/content/detail/R-HSA-983712"),
    "https://reactome.org/templates/favourite/favicon.ico"
  )

  # Example of a partial URL that gives a 404. Solved by reading the HTML for the
  # base URL.
  expect_identical_xl(
    faviconLink("https", "amigo.geneontology.org", "/amigo/term/"),
    "https://amigo.geneontology.org/static/images/go-logo-favicon.ico"
  )

  expect_identical_xl(
    faviconPlease("https://amigo.geneontology.org/amigo/term/"),
    "https://amigo.geneontology.org/static/images/go-logo-favicon.ico"
  )

  # Example of a protocol-relative URL
  # https://en.wikipedia.org/wiki/URL#prurl
  # https://stackoverflow.com/a/9646435
  expect_identical_xl(
    faviconLink("https", "www.ncbi.nlm.nih.gov", "/gene/"),
    "https://www.ncbi.nlm.nih.gov/favicon.ico"
  )

  expect_identical_xl(
    faviconPlease("https://www.ncbi.nlm.nih.gov/gene/"),
    "https://www.ncbi.nlm.nih.gov/favicon.ico"
  )

  expect_identical_xl(
    faviconPlease("http://www.ncbi.nlm.nih.gov/gene/"),
    "http://www.ncbi.nlm.nih.gov/favicon.ico"
  )

  # Example with <base>
  expect_identical(
    faviconLink("https", "www.gsea-msigdb.org", "/gsea/msigdb/cards/"),
    "https://www.gsea-msigdb.org/gsea/images/icon_32x32.png"
  )

  expect_identical(
    faviconPlease("https://www.gsea-msigdb.org/gsea/msigdb/cards/"),
    "https://www.gsea-msigdb.org/gsea/images/icon_32x32.png"
  )

  # Another example with <base>
  expect_identical(
    faviconLink("https", "www.targetvalidation.org", "/target/"),
    "https://www.targetvalidation.org/favicon.png"
  )

  expect_identical(
    faviconPlease("https://www.targetvalidation.org/target/"),
    "https://www.targetvalidation.org/favicon.png"
  )

  # Example of multiple rel="icon" (multiple sizes). The first one is always
  # returned. The link is site-relative.
  expect_identical(
    faviconLink("https", "www.r-project.org", "/"),
    "https://www.r-project.org/favicon-32x32.png"
  )

  expect_identical(
    faviconPlease("https://www.r-project.org/"),
    "https://www.r-project.org/favicon-32x32.png"
  )

  # Example of rel="icon" with absolute link
  expect_identical(
    faviconLink("https", "github.com", "/jdblischak/faviconPlease"),
    "https://github.githubassets.com/favicons/favicon.svg"
  )

  expect_identical(
    faviconPlease("https://github.com/jdblischak/faviconPlease"),
    "https://github.githubassets.com/favicons/favicon.svg"
  )
}
